package filtrexss;

/**
 *
 */


public class CollectionsUtil
{
        private static final char[] EMPTY_CHAR_ARRAY = new char[0];

        /**
         * Converts an array of chars to a Set of Characters.
         * @param array the contents of the new Set
         * @return a Set containing the elements in the array
         */
        public static Vector<Character> arrayToSet(char...array)
        {
                Vector<Character> toReturn;

                if(array == null)
                        return new Vector<Character>();
                toReturn = new Vector<Character>(array.length);
                for (char c : array) {
                        toReturn.addElement(c);
                }
                return toReturn;
        }

        /**
         * Convert a char array to a unmodifiable Set.
         * @param array the contents of the new Set
         * @return a unmodifiable Set containing the elements in the
         * array.
         */
  /*      public static Vector<Character> arrayToUnmodifiableSet(char...array)
        {
                if(array == null)
                        return Collections.emptySet();
                if(array.length == 1)
                        return Collections.singleton(array[0]);
                return Collections.unmodifiableSet(arrayToSet(array));
        }*/

        /**
         * Convert a String to a char array
         * @param str The string to convert
         * @return character array containing the characters in str. An
         *      empty array is returned if str is null.
         */
        public static char[] strToChars(String str)
        {
                int len;
                char[] ret;

                if(str == null)
                        return EMPTY_CHAR_ARRAY;
                len = str.length();
                ret = new char[len];
                str.getChars(0,len,ret,0);
                return ret;
        }

        /**
         * Convert a String to a set of characters.
         * @param str The string to convert
         * @return A set containing the characters in str. A empty set
         *      is returned if str is null.
         */
        public static Vector<Character> strToSet(String str)
        {
                Vector<Character> set;

                if(str == null)
                        return new Vector<Character>();
                set = new Vector<Character>(str.length());
                for(int i=0;i<str.length();i++)
                    if(!set.contains(i))
                        set.addElement(str.charAt(i));
                return set;
        }

        /**
         * Convert a String to a unmodifiable set of characters.
         * @param str The string to convert
         * @return A set containing the characters in str. A empty set
         *      is returned if str is null.
         */
        public static Vector<Character> strToUnmodifiableSet(String str)
        {
                if(str == null)
                        return new Vector<Character>();
                if(str.length() == 1)
                        return new Vector(str.charAt(0));
                return strToSet(str);
        }

        /**
         * Private constructor to prevent instantiation.
         */
        private CollectionsUtil()
        {
        }
}
